import { MessageInputContextValue } from '../../../context';
import { AudioRecorderConfig, MediaRecorderController, MediaRecordingState } from '../classes';
import type { LocalVoiceRecordingAttachment } from '../../MessageInput';
import type { DefaultStreamChatGenerics } from '../../../types';
export type CustomAudioRecordingConfig = Partial<AudioRecorderConfig>;
export type RecordingController = {
    completeRecording: () => void;
    permissionState?: PermissionState;
    recorder?: MediaRecorderController;
    recording?: LocalVoiceRecordingAttachment;
    recordingState?: MediaRecordingState;
};
type UseMediaRecorderParams<StreamChatGenerics extends DefaultStreamChatGenerics = DefaultStreamChatGenerics> = Pick<MessageInputContextValue<StreamChatGenerics>, 'asyncMessagesMultiSendEnabled' | 'handleSubmit' | 'uploadAttachment'> & {
    enabled: boolean;
    generateRecordingTitle?: (mimeType: string) => string;
    recordingConfig?: CustomAudioRecordingConfig;
};
export declare const useMediaRecorder: <StreamChatGenerics extends DefaultStreamChatGenerics = DefaultStreamChatGenerics>({ asyncMessagesMultiSendEnabled, enabled, generateRecordingTitle, handleSubmit, recordingConfig, uploadAttachment, }: UseMediaRecorderParams<StreamChatGenerics>) => RecordingController;
export {};
//# sourceMappingURL=useMediaRecorder.d.ts.map