import type { MessageInputReducerAction, MessageInputState } from './useMessageInputState';
import type { MessageInputProps } from '../MessageInput';
import type { LocalAttachment } from '../types';
import type { FileLike } from '../../ReactFileUtilities';
import type { CustomTrigger, DefaultStreamChatGenerics } from '../../../types/types';
export declare const useAttachments: <StreamChatGenerics extends DefaultStreamChatGenerics = DefaultStreamChatGenerics, V extends CustomTrigger = CustomTrigger>(props: MessageInputProps<StreamChatGenerics, V>, state: MessageInputState<StreamChatGenerics>, dispatch: import("react").Dispatch<MessageInputReducerAction<StreamChatGenerics>>, textareaRef: React.MutableRefObject<HTMLTextAreaElement | undefined>) => {
    maxFilesLeft: number;
    numberOfUploads: number;
    removeAttachment: (id: string) => void;
    removeFile: (id: string) => void;
    removeImage: (id: string) => void;
    uploadAttachment: (att: LocalAttachment<StreamChatGenerics>) => Promise<LocalAttachment<StreamChatGenerics>>;
    uploadFile: (id: string) => void;
    uploadImage: (id: string) => Promise<void>;
    uploadNewFiles: (files: FileList | File[] | FileLike[]) => void;
};
//# sourceMappingURL=useAttachments.d.ts.map