import React, { MouseEvent } from 'react';
import type { ImageUpload } from './types';
type CustomMouseEvent = (id: string, event: MouseEvent<HTMLButtonElement>) => void;
export type ImagePreviewerProps = {
    /** The list of image uploads that should be displayed */
    disabled?: boolean;
    /** A callback to call with newly selected files. If this is not provided no
     * `ThumbnailPlaceholder` will be displayed.
     */
    handleFiles?: (files: File[]) => void;
    /** A callback to call when the remove icon is clicked */
    handleRemove?: CustomMouseEvent;
    /** A callback to call when the retry icon is clicked */
    handleRetry?: CustomMouseEvent;
    imageUploads?: ImageUpload[];
    /** Allow drag 'n' drop (or selection from the file dialog) of multiple files */
    multiple?: boolean;
};
export declare const ImagePreviewer: ({ disabled, handleFiles, handleRemove, handleRetry, imageUploads, multiple, }: ImagePreviewerProps) => React.JSX.Element;
export {};
//# sourceMappingURL=ImagePreviewer.d.ts.map