export type RecordedMediaType = 'audio' | 'video';
export type UploadState = 'uploading' | 'finished' | 'failed';
export type FileLike = Blob | File;
export type UploadInfo = {
    id: string;
    state: UploadState;
    url?: string;
};
export type FileUpload = {
    file: {
        name: string;
        lastModified?: number;
        lastModifiedDate?: Date;
        size?: number;
        type?: string;
        uri?: string;
    };
} & UploadInfo;
export type ImageUpload = {
    file: {
        name: string;
        height?: number;
        lastModified?: number;
        lastModifiedDate?: Date;
        size?: number;
        type?: string;
        uri?: string;
        width?: number;
    };
    previewUri?: string;
} & UploadInfo;
//# sourceMappingURL=types.d.ts.map