import React from 'react';
import type { ReactionDetailsComparator, ReactionSummary } from './types';
import { ModalProps } from '../Modal';
import { MessageContextValue } from '../../context';
import { DefaultStreamChatGenerics } from '../../types/types';
type ReactionsListModalProps<StreamChatGenerics extends DefaultStreamChatGenerics = DefaultStreamChatGenerics> = ModalProps & Partial<Pick<MessageContextValue<StreamChatGenerics>, 'handleFetchReactions'>> & {
    reactions: ReactionSummary[];
    selectedReactionType: string | null;
    onSelectedReactionTypeChange?: (reactionType: string) => void;
    sortReactionDetails?: ReactionDetailsComparator;
};
export declare function ReactionsListModal({ handleFetchReactions, onSelectedReactionTypeChange, reactions, selectedReactionType, sortReactionDetails: propSortReactionDetails, ...modalProps }: ReactionsListModalProps): React.JSX.Element;
export {};
//# sourceMappingURL=ReactionsListModal.d.ts.map