import React, { PropsWithChildren } from 'react';
import { StreamMessage } from '../../context/ChannelStateContext';
import type { DefaultStreamChatGenerics } from '../../types/types';
export type WindowProps<StreamChatGenerics extends DefaultStreamChatGenerics = DefaultStreamChatGenerics> = {
    /** show or hide the window when a thread is active */
    hideOnThread?: boolean;
    /** optional prop to force addition of class str-chat__main-panel--hideOnThread to the Window root element */
    thread?: StreamMessage<StreamChatGenerics>;
};
/**
 * A UI component for conditionally displaying a Thread or Channel
 */
export declare const Window: <StreamChatGenerics extends DefaultStreamChatGenerics = DefaultStreamChatGenerics>(props: React.PropsWithChildren<WindowProps<StreamChatGenerics>>) => React.JSX.Element;
//# sourceMappingURL=Window.d.ts.map